/*
 * Copyright (c), 1994, SecureWare, Inc., All rights reserved.
 *
 * @(#)03 1.6 x11r5/extensions/include/xsecurity/Xsecos.h, xsecext, sco_3.0, 301FCS 06:17:05 11/21/94, SecureWare, Inc.
 */

#ifndef _XSECOS_H_
#define _XSECOS_H_

#include <sys/types.h>
#include <sys/security.h>

#if SEC_MAC /* { */
/*
 * This section defines the MAC Label implementation.
 *
 * MACLabel			the typedef
 *
 * MAC_LABEL_SIZE		size in bytes of the type
 *
 * MAC_LABEL_SIZE_RND		size rounded up to 32-bit boundary
 *
 * SWAP_MAC_LABEL		boolean, True if label needs to be swapped.
 *					implies integral # of 32-bit words.
 *
 * VALID_MAC_LABEL(label *)	Returns True if label valid, else false.
 *
 * COMPARE_MAC_LABEL(l1ptr, l2ptr)
 *				Returns  1 if l1 strictly dominates l2
 *				Returns  0 if l1 equals		    l2
 *				Returns -1 otherwise
 */

#include <mandatory.h>

typedef mand_ir_t		MACLabel;
typedef mand_ir_t		*MACLabelPtr;
#define SWAP_MAC_LABEL		(TRUE)
#define VALID_MAC_LABEL(l)	ValidMACLabel(l)

#define COMPARE_MAC_LABEL(l1, l2)	CompareMACLabel(l1, l2)

#define MAC_LABEL_SIZE		mand_bytes()
#define MAC_LABEL_SIZE_RND	mand_bytes()

#endif /* } SEC_MAC */

#if SEC_ILB /* { */
/*
 * This section defines the Information Label implementation.
 *
 * InfoLabel			the typedef
 *
 * INFO_LABEL_SIZE		size in bytes of the type
 *
 * INFO_LABEL_SIZE_RND		size rounded up to 32-bit boundary
 *
 * SWAP_INFO_LABEL		boolean, True if label needs to be swapped.
 *					implies integral # of 32-bit words.
 *
 * VALID_INFO_LABEL(label *)	Returns True if label valid, else false.
 *
 * COMPARE_INFO_LABEL(l1ptr, l2ptr)
 *				Returns  1 if l1 strictly dominates l2
 *				Returns  0 if l1 equals		    l2
 *				Returns -1 otherwise
 */

typedef ilb_ir_t		InfoLabel;
typedef ilb_ir_t		*InfoLabelPtr;
typedef ilb_ir_t		InputInfoLabel;
typedef ilb_ir_t		*InputInfoLabelPtr;

#define SWAP_INFO_LABEL		(TRUE)
#define VALID_INFO_LABEL(l)	ValidInfoLabel(l)

#define COMPARE_INFO_LABEL(l1, l2)	CompareInfoLabel(l1, l2)

#define INFO_LABEL_SIZE		ilb_bytes()
#define INFO_LABEL_SIZE_RND	ilb_bytes()

#endif /* } SEC_ILB */

typedef unsigned long	LoginUserID;
typedef unsigned long	UserID;
typedef unsigned long	GroupID;
typedef unsigned long	ProcessID;

typedef unsigned long	PrivWord;

#define PRIVWORD_SIZE	32		/* (in bits) */

#if SVR4 || hpux
#include <sys/resource.h>
#define GET_MAX_FILDES(var) { \
		struct rlimit r; \
		getrlimit(RLIMIT_NOFILE, &r); \
		var = r.rlim_max; \
		if (var == 0) \
			var = 1024; \
	}
#else /* SVR4 || hpux */
#if BSD || SCO || AUX || IBM
#define GET_MAX_FILDES(var)	(var = getdtablesize())
#endif /* BSD || SCO || AUX || IBM */
#endif /* SVR4 || hpux */
#endif	/* _XSECOS_H_ */
